#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Ivan Jose Cernicharo Ortiz (ivan.cernicharo@bsc.es)
#             -
#             -
#

import sys
import logging
import os
import subprocess

# The code below is intend to check max an min values and check masks for netcdf
# Could be useful for this partSS
# list_of_ranges = list()
# for i,f in enumerate(final_files):
#     #print(' >> '.join([str(i),f]))
#     ncitem = netCDF4.Dataset(f)
#     test_var = [item for item in ncitem.variables.keys() if (item not in ncitem.dimensions.keys() and item not in ['sic','lev'])]
#     if test_var != []:
#         for e in test_var:
#             if e.strip().lower() not in ['realization','time_bnds']:
#                 var = ncitem.variables[e]
#                 variable = var[:]
#                 if var.mask == False:
#                     vmax = np.max(var)
#                     vmin = np.min(var)
#                     mk = False
#                 else:
#                     data_masked = variable.mask
#                     data = variable.data
#                     real_data = data[~data_masked]
#                     vmax = np.max(real_data)
#                     vmin = np.min(real_data)
#                     mk = True
#                 string = '\n>> ' + str(e)+ ' variable\n\t >> MAX: ' + str(vmax) + '\n\t >> MIN: ' + str(vmin) + '\n'
#                 if ncitem.variables[e].shape[0] != 1:
#                     print(e,ncitem.variables[e].shape)
#                 if ncitem.variables[e].shape[0] > 1:
#                     freqq = np.unique(np.diff(ncitem.variables['time'][:]))
#                     print(freqq)
#                     freq = [freqq,ncitem.variables[e].shape[0]]
#                 else:
#                     freq = ['Monthly',1]
#                 list_of_ranges.append([e,ncitem.variables['time'].units.split()[2],vmax,vmin,freq,mk])   

class spatial_completeness_test:

    def __init__(self,type,files):
        self.type = type
        self.files = files